#pragma once

#include <Plasma/DataEngine>
 
#include <QTimer>

class QHttp;

class StockQuoteEngine : public Plasma::DataEngine
{
    Q_OBJECT
 
  public:
    StockQuoteEngine(QObject* parent, const QVariantList& args);
    ~StockQuoteEngine();

  protected:
    bool sourceRequestEvent(const QString& name);

  private slots:
    void update();
    void requestFinished(int id, bool error);

  private:
    QString fixQuotes(const QString& string);

    QHttp* m_http;
    QTimer m_timer;
    QTimer m_add_timer;
};

